<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_conveythis
 *
 * @copyright   Copyright (C) 2018 www.conveythis.com, All rights reserved.
 * @license     ConveyThis Translate is licensed under GPLv2 license; see LICENSE.txt
 */
defined('_JEXEC') or die('Restricted access');
?>
<style>
	#setting-error-settings_updated span {
		text-transform: uppercase;
	}

	.wp-core-ui .button {
		height: initial;
	}
	
	body { 
		background: #f1f1f2;
	}

	.header {
		background-color: transparent;
	}
	header.header {
	    background-color: #1a3867;
	}

	@media (min-width: 1200px)
	.row {
		margin-left: 0;
	}

	.row {
		margin-left: 0;
	}

	input[type="text"] {
		height: auto;
	}

	.radio, .checkbox {
		padding-left: 0;
	}

	.radio input[type="radio"], .checkbox input[type="checkbox"] {
		margin-left: 0;
	}
</style>

<?php if( !empty( $error ) ): ?>

<div class="ui negative message">
	<div><?php echo $error['message']; ?></div>
</div>

<?php endif;?>



<div class="ui active inverted dimmer">
	<div class="ui text loader">Loading</div>
</div>

<div class="wrap">
	<form class="conveythis-widget-option-form" style="max-width: 60%; min-width: 1024px; position: relative;" method="post" action="<?php echo JRoute::_('index.php?option=com_conveythis'); ?>">

		<h3 class="ui dividing header">
			<?php echo JText::_( 'Main configuration' ); ?>
		</h3>

		<div class="ui card" style="position: absolute; right: 0; z-index: 1;">
			<div class="content">
				<div class="header"><?php echo JText::_( 'Preview' ); ?></div>
			</div>
			<div class="content" style="height:70px">
				<div id="customize-view-button" style="z-index: 1;"></div>
			</div>
		</div>

		<div class="ui grid">

			<div class="three wide column">
				<h4 class="ui header">
					<?php echo JText::_( 'API Key' ); ?>
				</h4>
			</div>
			<div class="two column row">
				<div class="three wide column">
					<p>
						<?php
							$message = JText::_( 'Log in to %1$sConveyThis%2$s to get your API key.' );
							echo sprintf( $message, '<a target="_blank" href="http://conveythis.com/dashboard/register.php">', '</a>' );
						?>
					</p>
				</div>
				<div class="five wide column">
					<div class="ui fluid input">
						<input type="text" name="api_key" value="<?php echo $api_key; ?>" placeholder="pub_XXXXXXXX" />
					</div>
				</div>
			</div>

			<div class="three wide column">
				<h4 class="ui header">
					<?php echo JText::_( 'Source Language' ); ?>
				</h4>
			</div>
			<div class="two column row">
				<div class="three wide column">
					<p>
						<?php echo JText::_( 'What is the source (current) language of your website?' ); ?>
					</p>
				</div>
				<div class="four wide column">

					<div class="ui fluid search selection dropdown">
						<input type="hidden" name="source_language" value="<?php echo $source_language; ?>">
						<i class="dropdown icon"></i>
						<div class="default text">Select source language</div>
						<div class="menu">

							<?php foreach( $languages as $language ): ?>

								<div class="item" data-value="<?php echo $language['code2']; ?>">
									<?php echo JText::_( $language['title'] ); ?>
								</div>

							<?php endforeach; ?>

						</div>
					</div>

				</div>
			</div>

			<div class="three wide column">
				<h4 class="ui header">
					<?php echo JText::_( 'Target Languages' ); ?>
				</h4>
			</div>
			<div class="two column row">
				<div class="three wide column">
					<p>
						<?php echo JText::_( 'Choose languages you want to translate into.' ); ?>
					</p>
				</div>
				<div class="six wide column">

					<div class="ui fluid multiple search selection dropdown">
						<input type="hidden" name="target_languages" value="<?php echo implode( ',', $target_languages ); ?>">
						<i class="dropdown icon"></i>
						<div class="default text">French, German, Italian, Portuguese, …</div>
						<div class="menu">

						<?php foreach( $languages as $language ): ?>

							<div class="item" data-value="<?php echo $language['code2']; ?>">
								<?php echo JText::_( $language['title'] ); ?>
							</div>

						<?php endforeach; ?>

						</div>
					</div>

				</div>
			</div>

			<div class="two column row">
				<div class="three wide column">

				</div>
				<div class="eight wide column">
					<p>
						<?php
							$message = JText::_( 'On the free plan, you can only choose one target language. If you want to use more than 1 language, please %1$supgrade your plan%2$s.' );
							echo sprintf( $message, '<a target="_blank" href="https://www.conveythis.com/dashboard/pricing/">', '</a>' );
						?>
					</p>
				</div>
			</div>

			<?php if( !empty( $api_key ) ): ?>

			<div class="three wide column">
				<h4 class="ui header">
					<?php echo JText::_( 'Where are my translations?' ); ?>
				</h4>
			</div>
			<div class="two column row">
				<div class="three wide column">
					<p>
						<?php echo JText::_( 'You can find all your translations in your account' ); ?>
					</p>
				</div>
				<div class="three wide column">
					<?php
						$message = JText::_( '%1$sEdit My Translations%2$s' );
						echo sprintf( $message, '<a target="_blank" href="https://www.conveythis.com/dashboard/translation.php">', '</a>' );
					?>
				</div>
			</div>

			<?php endif; ?>

		</div>

		<br>
		<br>
		<div style="border-bottom: 1px solid rgba(34,36,38,.15); padding-bottom: 10px;">
			<a href="#" id="customize-tab-toogle"><?php echo JText::_( 'Show more options' ); ?></a>				
		</div>

		<div id="customize-tab" style="display: none">

			<h3 class="ui dividing header">
				<?php echo JText::_( 'Customize button' ); ?>
			</h3>
			<div class="ui grid">
				<div class="three wide column">
					<h4 class="ui header">
						<?php echo JText::_( 'Picture' ); ?>
					</h4>
				</div>
				<div class="two column row">
					<div class="three wide column">
						<?php echo JText::_( 'Select the display style for flags' ); ?>
					</div>
					<div class="three wide column">
						<div class="ui form">
							<div class="grouped fields">
								<div class="field">
									<div class="ui radio checkbox">
										<?php if( !empty( $style_flag ) && $style_flag == 'rect' ): ?>

											<input type="radio" name="style_flag" value="rect" checked="checked">

										<?php else: ?>

											<input type="radio" name="style_flag" value="rect">

										<?php endif; ?>
										<label><?php echo JText::_( 'Rectangle flag' ); ?></label>
									</div>
								</div>
								<div class="field">
									<div class="ui radio checkbox">
										<?php if( !empty( $style_flag ) && $style_flag == 'sqr' ): ?>

											<input type="radio" name="style_flag" value="sqr" checked="checked">

										<?php else: ?>

											<input type="radio" name="style_flag" value="sqr">

										<?php endif; ?>
										<label><?php echo JText::_( 'Square flag' ); ?></label>
									</div>
								</div>
								<div class="field">
									<div class="ui radio checkbox">
										<?php if( !empty( $style_flag ) && $style_flag == 'cir' ): ?>

											<input type="radio" name="style_flag" value="cir" checked="checked">

										<?php else: ?>

											<input type="radio" name="style_flag" value="cir">

										<?php endif; ?>
										<label><?php echo JText::_( 'Circle flag' ); ?></label>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>

				<div class="three wide column">
					<h4 class="ui header">
						<?php echo JText::_( 'Text' ); ?>
					</h4>
				</div>
				<div class="two column row">
					<div class="three wide column">
						<?php echo JText::_( 'Display the text name of the language' ); ?>
					</div>
					<div class="three wide column">
						<div class="ui form">
							<div class="grouped fields">
								<div class="field">
									<div class="ui radio checkbox">
										<?php if( !empty( $style_text ) && $style_text == 'full-text' ): ?>

											<input type="radio" name="style_text" value="full-text" checked="checked">

										<?php else: ?>

											<input type="radio" name="style_text" value="full-text">

										<?php endif; ?>
										<label><?php echo JText::_( 'Full text' ); ?></label>
									</div>
								</div>
								<div class="field">
									<div class="ui radio checkbox">
										<?php if( !empty( $style_text ) && $style_text == 'short-text' ): ?>

											<input type="radio" name="style_text" value="short-text" checked="checked">

										<?php else: ?>

											<input type="radio" name="style_text" value="short-text">

										<?php endif; ?>
										<label><?php echo JText::_( 'Short text' ); ?></label>
									</div>
								</div>
								<div class="field">
									<div class="ui radio checkbox">
										<?php if( !empty( $style_text ) && $style_text == 'without-text' ): ?>

											<input type="radio" name="style_text" value="without-text" checked="checked">

										<?php else: ?>

											<input type="radio" name="style_text" value="without-text">

										<?php endif; ?>
										<label><?php echo JText::_( 'Without text' ); ?></label>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>

				<div class="three wide column">
					<h4 class="ui header">
						<?php echo JText::_( 'Position' ); ?>
					</h4>
				</div>
				<div class="two column row">
					<div class="three wide column">
						<?php echo JText::_( 'Location of the language selection button on the site' ); ?>
					</div>
					<div class="three wide column">
						<div class="ui form">
							<div class="grouped fields">
								<div class="field">
									<div class="ui radio checkbox">
										<?php if( !empty( $style_position ) && $style_position == 'right-top' ): ?>

											<input type="radio" name="style_position" value="right-top" checked="checked">

										<?php else: ?>

											<input type="radio" name="style_position" value="right-top">

										<?php endif; ?>
										<label><?php echo JText::_( 'Right Top' ); ?></label>
									</div>
								</div>
								<div class="field">
									<div class="ui radio checkbox">
										<?php if( !empty( $style_position ) && $style_position == 'right-bottom' ): ?>

											<input type="radio" name="style_position" value="right-bottom" checked="checked">

										<?php else: ?>

											<input type="radio" name="style_position" value="right-bottom">

										<?php endif; ?>
										<label><?php echo JText::_( 'Right Bottom' ); ?></label>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>

				<div class="three wide column">
					<h4 class="ui header">
						<?php echo JText::_( 'Indenting' ); ?>
					</h4>
				</div>
				<div class="three column row">
					<div class="three wide column">
						<?php echo JText::_( 'Vertical spacing from the top or bottom of the browser' ); ?>
					</div>
					<div class="one wide column">
						<input type="hidden" name="style_indenting" value="<?php echo $style_indenting; ?>">
						<span id="display-3"><?php echo $style_indenting; ?></span>px
					</div>
					<div class="nine wide column">
						<div class="ui grey range" id="range-3"></div>
					</div>
				</div>

			</div>

			<h3 class="ui dividing header">
				<?php echo JText::_( 'SEO' ); ?>
			</h3>
			<div class="ui grid">
				<div class="two column row">
					<div class="three wide column">
						<?php echo JText::_( 'Hreflang tags' ); ?>
					</div>
					<div class="four wide column">
						<div class="ui checkbox">

							<?php if( $alternate == 1 ): ?>

								<input type="checkbox" name="alternate" value="1" checked="checked">

							<?php else: ?>

								<input type="checkbox" name="alternate" value="1">

							<?php endif; ?>

							<label><?php echo JText::_( 'Add to all pages' ); ?></label>
						</div>
					</div>
				</div>
			</div>

			<br>
			<br>
			<div style="border-bottom: 1px solid rgba(34,36,38,.15); padding-bottom: 10px;">
				<a href="#" id="change-tab-toogle"><?php echo JText::_( 'Change language flag' ); ?></a>
			</div>

			<div id="change-tab" style="display: none">

				<h3 class="ui dividing header">
					<?php echo JText::_( 'Change flag' ); ?>
				</h3>
				<div class="ui grid">

					<div class="one column row">
						<div class="nine wide column">
							<p>
								<?php echo JText::_( 'By default all the languages have their flags in accordance with ISO standards. If you want to change the flag for one or several languages here you can customize this.' ); ?>
							</p>
						</div>
					</div>

					<?php $i = 0; ?>
					<?php while( $i < 5 ): ?>

					<div class="three column row">

						<div class="three wide column">

							<div class="ui fluid search selection dropdown">
								<input type="hidden" name="style_change_language[]" value="<?php echo ( !empty ( $style_change_language[$i] ) ) ? $style_change_language[$i] : ''; ?>">
								<i class="dropdown icon"></i>
								<div class="default text">Select language</div>
								<div class="menu">

									<?php foreach( $languages as $id => $language ): ?>

										<div class="item" data-value="<?php echo $id; ?>">
											<?php echo JText::_( $language['title'] ); ?>
										</div>

									<?php endforeach; ?>

								</div>
							</div>

						</div>
						<div class="five wide column">

							<div class="ui fluid search selection dropdown">
								<input type="hidden" name="style_change_flag[]"  value="<?php echo ( !empty ( $style_change_flag[$i] ) ) ? $style_change_flag[$i] : ''; ?>">
								<i class="dropdown icon"></i>
								<div class="default text">Select Flag</div>
								<div class="menu">

									<?php foreach( $flags as $flag ): ?>

										<div class="item" data-value="<?php echo $flag['code']; ?>">
											<div class="ui image" style="height: 28px; width: 42px; background-position: 50% 50%; background-repeat: no-repeat; background-image: url('//cdn.conveythis.com/images/flags/v2/rectangular/<?php echo $flag['code']; ?>.png')"></div>
											<?php echo JText::_( $flag['title'] ); ?>
										</div>

									<?php endforeach; ?>

								</div>
							</div>

						</div>

						<div class="three wide column">
							<button class="ui icon button">
								<i class="close icon"></i>
							</button>
						</div>

					</div>

					<?php $i++; ?>
					<?php endwhile; ?>

				</div>
			</div>

			</div><!-- #change-tab -->
		<br>
		<button type="submit" class="ui primary button">Save</button>
	</form>

	<p>
		Love ConveyThis? Give us 5 stars on Joomla! Extensions Directory
	</p>
	<p>
		If you need any help, you can contact us via our live chat at <a href="https://www.conveythis.com" target="_blank">www.ConveyThis.com</a> or email us at support@conveythis.com. You can also check our <a href="https://www.conveythis.com/support/faq/" target="_blank">FAQ</a>
	</p>
</div>
