<?php
/**
 * @package     Joomla.Plugin
 * @subpackage  System.Conveythis
 *
 * @copyright   Copyright (C) 2018 www.conveythis.com, All rights reserved.
 * @license     ConveyThis Translate is licensed under GPLv2 license; see LICENSE.txt
 */
defined( '_JEXEC' ) or die;

class plgSystemConveythis extends JPlugin
{
	var $segments = array();
	var $api_url = 'https://api.conveythis.com/15';

	var $languages = array(
		703 => array( 'title' => 'English', 'code2' => 'en', 'code3' => 'eng', 'flag' => 'Dw0' ),
		704 => array( 'title' => 'Afrikaans', 'code2' => 'af', 'code3' => 'afr', 'flag' => '7xS' ),
		705 => array( 'title' => 'Albanian', 'code2' => 'sq', 'code3' => 'sqi', 'flag' => '5iM' ),
		706 => array( 'title' => 'Amharic', 'code2' => 'am', 'code3' => 'amh', 'flag' => 'ZH1' ),
		707 => array( 'title' => 'Arabic', 'code2' => 'ar', 'code3' => 'ara', 'flag' => 'J06' ),
		708 => array( 'title' => 'Armenian', 'code2' => 'hy', 'code3' => 'hye', 'flag' => 'q9U' ),
		709 => array( 'title' => 'Azerbaijan', 'code2' => 'az', 'code3' => 'aze', 'flag' => 'Wg1' ),
		710 => array( 'title' => 'Bashkir', 'code2' => 'ba', 'code3' => 'bak', 'flag' => 'D1H' ),
		711 => array( 'title' => 'Basque', 'code2' => 'eu', 'code3' => 'eus', 'flag' => 'none' ),
		712 => array( 'title' => 'Belarusian', 'code2' => 'be', 'code3' => 'bel', 'flag' => 'O8S' ),
		713 => array( 'title' => 'Bengali', 'code2' => 'bn', 'code3' => 'ben', 'flag' => '63A' ),
		714 => array( 'title' => 'Bosnian', 'code2' => 'bs', 'code3' => 'bos', 'flag' => 'Z1t' ),
		715 => array( 'title' => 'Bulgarian', 'code2' => 'bg', 'code3' => 'bul', 'flag' => 'V3p' ),
		716 => array( 'title' => 'Burmese', 'code2' => 'my', 'code3' => 'mya', 'flag' => 'YB9' ),
		717 => array( 'title' => 'Catalan', 'code2' => 'ca', 'code3' => 'cat', 'flag' => 'Pw6' ),
		718 => array( 'title' => 'Cebuano', 'code2' => 'ceb', 'code3' => 'ceb', 'flag' => 'none' ),
		719 => array( 'title' => 'Chinese', 'code2' => 'zh', 'code3' => 'zho', 'flag' => 'Z1v' ),
		720 => array( 'title' => 'Croatian', 'code2' => 'hr', 'code3' => 'hrv', 'flag' => '7KQ' ),
		721 => array( 'title' => 'Czech', 'code2' => 'cs', 'code3' => 'cze', 'flag' => '1ZY' ),
		722 => array( 'title' => 'Danish', 'code2' => 'da', 'code3' => 'dan', 'flag' => 'Ro2' ),
		723 => array( 'title' => 'Dutch', 'code2' => 'nl', 'code3' => 'nld', 'flag' => '8jV' ),
		724 => array( 'title' => 'Esperanto', 'code2' => 'eo', 'code3' => 'epo', 'flag' => 'Dw0' ),
		725 => array( 'title' => 'Estonian', 'code2' => 'et', 'code3' => 'est', 'flag' => 'VJ8' ),
		726 => array( 'title' => 'Finnish', 'code2' => 'fi', 'code3' => 'fin', 'flag' => 'nM4' ),
		727 => array( 'title' => 'French', 'code2' => 'fr', 'code3' => 'fre', 'flag' => 'E77' ),
		728 => array( 'title' => 'Galician', 'code2' => 'gl', 'code3' => 'glg', 'flag' => 'A5d' ),
		729 => array( 'title' => 'Georgian', 'code2' => 'ka', 'code3' => 'kat', 'flag' => '8Ou' ),
		730 => array( 'title' => 'German', 'code2' => 'de', 'code3' => 'ger', 'flag' => 'K7e' ),
		731 => array( 'title' => 'Greek', 'code2' => 'el', 'code3' => 'ell', 'flag' => 'kY8' ),
		732 => array( 'title' => 'Gujarati', 'code2' => 'gu', 'code3' => 'guj', 'flag' => 'My6' ),
		733 => array( 'title' => 'Haitian', 'code2' => 'ht', 'code3' => 'hat', 'flag' => 'none' ),
		734 => array( 'title' => 'Hebrew', 'code2' => 'he', 'code3' => 'heb', 'flag' => '5KS' ),
		735 => array( 'title' => 'Hill Mari', 'code2' => 'mrj', 'code3' => 'mrj', 'flag' => 'none' ),
		736 => array( 'title' => 'Hindi', 'code2' => 'hi', 'code3' => 'hin', 'flag' => 'My6' ),
		737 => array( 'title' => 'Hungarian', 'code2' => 'hu', 'code3' => 'hun', 'flag' => 'OU2' ),
		738 => array( 'title' => 'Icelandic', 'code2' => 'is', 'code3' => 'isl', 'flag' => 'Ho8' ),
		739 => array( 'title' => 'Indonesian', 'code2' => 'id', 'code3' => 'ind', 'flag' => 't0X' ),
		740 => array( 'title' => 'Irish', 'code2' => 'ga', 'code3' => 'gle', 'flag' => '5Tr' ),
		741 => array( 'title' => 'Italian', 'code2' => 'it', 'code3' => 'ita', 'flag' => 'BW7' ),
		742 => array( 'title' => 'Japanese', 'code2' => 'ja', 'code3' => 'jpn', 'flag' => '4YX' ),
		743 => array( 'title' => 'Javanese', 'code2' => 'jv', 'code3' => 'jav', 'flag' => 'C9k' ),
		744 => array( 'title' => 'Kannada', 'code2' => 'kn', 'code3' => 'kan', 'flag' => 'My6' ),
		745 => array( 'title' => 'Kazakh', 'code2' => 'kk', 'code3' => 'kaz', 'flag' => 'QA5' ),
		746 => array( 'title' => 'Khmer', 'code2' => 'km', 'code3' => 'khm', 'flag' => 'o8B' ),
		747 => array( 'title' => 'Korean', 'code2' => 'ko', 'code3' => 'kor', 'flag' => '0W3' ),
		748 => array( 'title' => 'Kyrgyz', 'code2' => 'ky', 'code3' => 'kir', 'flag' => 'uP6' ),
		749 => array( 'title' => 'Laotian', 'code2' => 'lo', 'code3' => 'lao', 'flag' => 'Qy5' ),
		750 => array( 'title' => 'Latin', 'code2' => 'la', 'code3' => 'lat', 'flag' => 'BW7' ),
		751 => array( 'title' => 'Latvian', 'code2' => 'lv', 'code3' => 'lav', 'flag' => 'j1D' ),
		752 => array( 'title' => 'Lithuanian', 'code2' => 'lt', 'code3' => 'lit', 'flag' => 'uI6' ),
		753 => array( 'title' => 'Luxemb', 'code2' => 'lb', 'code3' => 'ltz', 'flag' => 'EV8' ),
		754 => array( 'title' => 'Macedonian', 'code2' => 'mk', 'code3' => 'mkd', 'flag' => '6GV' ),
		755 => array( 'title' => 'Malagasy', 'code2' => 'mg', 'code3' => 'mlg', 'flag' => '4tE' ),
		756 => array( 'title' => 'Malay', 'code2' => 'ms', 'code3' => 'msa', 'flag' => 'C9k' ),
		757 => array( 'title' => 'Malayalam', 'code2' => 'ml', 'code3' => 'mal', 'flag' => 'My6' ),
		758 => array( 'title' => 'Maltese', 'code2' => 'mt', 'code3' => 'mlt', 'flag' => 'N11' ),
		759 => array( 'title' => 'Maori', 'code2' => 'mi', 'code3' => 'mri', 'flag' => '0Mi' ),
		760 => array( 'title' => 'Marathi', 'code2' => 'mr', 'code3' => 'mar', 'flag' => 'My6' ),
		761 => array( 'title' => 'Mari', 'code2' => 'mhr', 'code3' => 'chm', 'flag' => 'none' ),
		762 => array( 'title' => 'Mongolian', 'code2' => 'mn', 'code3' => 'mon', 'flag' => 'X8h' ),
		763 => array( 'title' => 'Nepali', 'code2' => 'ne', 'code3' => 'nep', 'flag' => 'E0c' ),
		764 => array( 'title' => 'Norwegian', 'code2' => 'no', 'code3' => 'nor', 'flag' => '4KE' ),
		765 => array( 'title' => 'Papiamento', 'code2' => 'pap', 'code3' => 'pap', 'flag' => 'none' ),
		766 => array( 'title' => 'Persian', 'code2' => 'fa', 'code3' => 'per', 'flag' => 'Vo7' ),
		767 => array( 'title' => 'Polish', 'code2' => 'pl', 'code3' => 'pol', 'flag' => 'j0R' ),
		768 => array( 'title' => 'Portuguese', 'code2' => 'pt', 'code3' => 'por', 'flag' => '1oU' ),
		769 => array( 'title' => 'Punjabi', 'code2' => 'pa', 'code3' => 'pan', 'flag' => 'n4T' ),
		770 => array( 'title' => 'Romanian', 'code2' => 'ro', 'code3' => 'rum', 'flag' => 'V5u' ),
		771 => array( 'title' => 'Russian', 'code2' => 'ru', 'code3' => 'rus', 'flag' => 'D1H' ),
		772 => array( 'title' => 'Scottish', 'code2' => 'gd', 'code3' => 'gla', 'flag' => '9MI' ),
		773 => array( 'title' => 'Serbian', 'code2' => 'sr', 'code3' => 'srp', 'flag' => 'GC6' ),
		774 => array( 'title' => 'Sinhala', 'code2' => 'si', 'code3' => 'sin', 'flag' => '9JL' ),
		775 => array( 'title' => 'Slovakian', 'code2' => 'sk', 'code3' => 'slk', 'flag' => 'Y2i' ),
		776 => array( 'title' => 'Slovenian', 'code2' => 'sl', 'code3' => 'slv', 'flag' => 'ZR1' ),
		777 => array( 'title' => 'Spanish', 'code2' => 'es', 'code3' => 'spa', 'flag' => 'A5d' ),
		778 => array( 'title' => 'Sundanese', 'code2' => 'su', 'code3' => 'sun', 'flag' => 'Wh1' ),
		779 => array( 'title' => 'Swahili', 'code2' => 'sw', 'code3' => 'swa', 'flag' => 'X3y' ),
		780 => array( 'title' => 'Swedish', 'code2' => 'sv', 'code3' => 'swe', 'flag' => 'oZ3' ),
		781 => array( 'title' => 'Tagalog', 'code2' => 'tl', 'code3' => 'tgl', 'flag' => '2qL' ),
		782 => array( 'title' => 'Tajik', 'code2' => 'tg', 'code3' => 'tgk', 'flag' => '7Qa' ),
		783 => array( 'title' => 'Tamil', 'code2' => 'ta', 'code3' => 'tam', 'flag' => 'My6' ),
		784 => array( 'title' => 'Tatar', 'code2' => 'tt', 'code3' => 'tat', 'flag' => 'D1H' ),
		785 => array( 'title' => 'Telugu', 'code2' => 'te', 'code3' => 'tel', 'flag' => 'My6' ),
		786 => array( 'title' => 'Thai', 'code2' => 'th', 'code3' => 'tha', 'flag' => 'V6r' ),
		787 => array( 'title' => 'Turkish', 'code2' => 'tr', 'code3' => 'tur', 'flag' => 'YZ9' ),
		788 => array( 'title' => 'Udmurt', 'code2' => 'udm', 'code3' => 'udm', 'flag' => 'none' ),
		789 => array( 'title' => 'Ukrainian', 'code2' => 'uk', 'code3' => 'ukr', 'flag' => '2Mg' ),
		790 => array( 'title' => 'Urdu', 'code2' => 'ur', 'code3' => 'urd', 'flag' => 'n4T' ),
		791 => array( 'title' => 'Uzbek', 'code2' => 'uz', 'code3' => 'uzb', 'flag' => 'zJ3' ),
		792 => array( 'title' => 'Vietnamese', 'code2' => 'vi', 'code3' => 'vie', 'flag' => 'l2A' ),
		793 => array( 'title' => 'Welsh', 'code2' => 'cy', 'code3' => 'wel', 'flag' => 'D4b' ),
		794 => array( 'title' => 'Xhosa', 'code2' => 'xh', 'code3' => 'xho', 'flag' => '7xS' ),
		795 => array( 'title' => 'Yiddish', 'code2' => 'yi', 'code3' => 'yid', 'flag' => '5KS' ),
	);

	var $flags = array(
		312 => array( 'title' => 'Afghanistan', 'code' => 'NV2'),
		313 => array( 'title' => 'Albania', 'code' => '5iM'),
		314 => array( 'title' => 'Algeria', 'code' => '5W5'),
		315 => array( 'title' => 'Andorra', 'code' => '0Iu'),
		316 => array( 'title' => 'Angola', 'code' => 'R3d'),
		317 => array( 'title' => 'Antigua and Barbuda', 'code' => '16M'),
		318 => array( 'title' => 'Argentina', 'code' => 'V1f'),
		319 => array( 'title' => 'Armenia', 'code' => 'q9U'),
		320 => array( 'title' => 'Australia', 'code' => '2Os'),
		321 => array( 'title' => 'Austria', 'code' => '8Dv'),
		322 => array( 'title' => 'Azerbaijan', 'code' => 'Wg1'),
		323 => array( 'title' => 'Bahamas', 'code' => '0qL'),
		324 => array( 'title' => 'Bahrain', 'code' => 'D9A'),
		325 => array( 'title' => 'Bangladesh', 'code' => '63A'),
		326 => array( 'title' => 'Barbados', 'code' => 'u7L'),
		327 => array( 'title' => 'Belarus', 'code' => 'O8S'),
		328 => array( 'title' => 'Belgium', 'code' => '0AT'),
		329 => array( 'title' => 'Belize', 'code' => 'lH4'),
		330 => array( 'title' => 'Benin', 'code' => 'I2x'),
		331 => array( 'title' => 'Bhutan', 'code' => 'D9z'),
		332 => array( 'title' => 'Bolgariya', 'code' => 'V3p'),
		333 => array( 'title' => 'Bolivia', 'code' => '8Vs'),
		334 => array( 'title' => 'Bosnia and Herzegovina', 'code' => 'Z1t'),
		335 => array( 'title' => 'Botswana', 'code' => 'Vf3'),
		336 => array( 'title' => 'Brazil', 'code' => '1oU'),
		337 => array( 'title' => 'Brunei', 'code' => '3rE'),
		338 => array( 'title' => 'Burkina Faso', 'code' => 'x8P'),
		339 => array( 'title' => 'Burundi', 'code' => '5qZ'),
		340 => array( 'title' => 'Cambodia', 'code' => 'o8B'),
		341 => array( 'title' => 'Cameroon', 'code' => '3cO'),
		342 => array( 'title' => 'Canada', 'code' => 'P4g'),
		343 => array( 'title' => 'Cape Verde', 'code' => 'R5O'),
		344 => array( 'title' => 'Central African Republic', 'code' => 'kN9'),
		345 => array( 'title' => 'Chad', 'code' => 'V5u'),
		346 => array( 'title' => 'Chile', 'code' => 'wY3'),
		347 => array( 'title' => 'China', 'code' => 'Z1v'),
		348 => array( 'title' => 'Colombia', 'code' => 'a4S'),
		349 => array( 'title' => 'Comoros', 'code' => 'N6k'),
		350 => array( 'title' => 'Congo', 'code' => 'WK0'),
		351 => array( 'title' => 'Costa Rica', 'code' => 'PP7'),
		352 => array( 'title' => 'Cote d\'Ivoire', 'code' => '6PX'),
		353 => array( 'title' => 'Croatia', 'code' => '7KQ'),
		354 => array( 'title' => 'Cuba', 'code' => 'vU2'),
		355 => array( 'title' => 'Cyprys', 'code' => 'Gw4'),
		356 => array( 'title' => 'Czech Republic', 'code' => '1ZY'),
		357 => array( 'title' => 'Democratic Republic of the Congo', 'code' => 'Kv5'),
		358 => array( 'title' => 'Denmark', 'code' => 'Ro2'),
		359 => array( 'title' => 'Djibouti', 'code' => 'MS7'),
		360 => array( 'title' => 'Dominica', 'code' => 'E7U'),
		361 => array( 'title' => 'Dominican Republic', 'code' => 'Eu2'),
		362 => array( 'title' => 'Ecuador', 'code' => 'D90'),
		363 => array( 'title' => 'Egypt', 'code' => '7LL'),
		364 => array( 'title' => 'El Salvador', 'code' => '0zL'),
		365 => array( 'title' => 'Equatorial Guinea', 'code' => 'b8T'),
		366 => array( 'title' => 'Eritrea', 'code' => '8Gl'),
		367 => array( 'title' => 'Estonia', 'code' => 'VJ8'),
		368 => array( 'title' => 'Ethiopia', 'code' => 'ZH1'),
		369 => array( 'title' => 'Fiji', 'code' => 'E1f'),
		370 => array( 'title' => 'Finland', 'code' => 'nM4'),
		371 => array( 'title' => 'France', 'code' => 'E77'),
		372 => array( 'title' => 'Gabon', 'code' => 'R1u'),
		373 => array( 'title' => 'Gambia', 'code' => 'TZ6'),
		374 => array( 'title' => 'Georgia', 'code' => '8Ou'),
		375 => array( 'title' => 'German', 'code' => 'K7e'),
		376 => array( 'title' => 'Ghana', 'code' => '6Mr'),
		377 => array( 'title' => 'Greece', 'code' => 'kY8'),
		378 => array( 'title' => 'Grenada', 'code' => 'yG1'),
		379 => array( 'title' => 'Guatemala', 'code' => 'aD8'),
		380 => array( 'title' => 'Guinea', 'code' => '6Lm'),
		381 => array( 'title' => 'Guinea-Bissau', 'code' => 'I39'),
		382 => array( 'title' => 'Guyana', 'code' => 'Mh5'),
		383 => array( 'title' => 'Haiti', 'code' => 'Qx7'),
		384 => array( 'title' => 'Honduras', 'code' => 'm5Q'),
		385 => array( 'title' => 'Hungary ', 'code' => 'OU2'),
		386 => array( 'title' => 'Iceland', 'code' => 'Ho8'),
		387 => array( 'title' => 'India', 'code' => 'My6'),
		388 => array( 'title' => 'Indonesia', 'code' => 'G0m'),
		389 => array( 'title' => 'Iran', 'code' => 'Vo7'),
		390 => array( 'title' => 'Iraq', 'code' => 'z7I'),
		391 => array( 'title' => 'Ireland', 'code' => '5Tr'),
		392 => array( 'title' => 'Israel', 'code' => '5KS'),
		393 => array( 'title' => 'Italy', 'code' => 'BW7'),
		394 => array( 'title' => 'Jamaica', 'code' => 'u6W'),
		395 => array( 'title' => 'Japan', 'code' => '4YX'),
		396 => array( 'title' => 'Jordan', 'code' => 's2B'),
		397 => array( 'title' => 'Kazakhstan', 'code' => 'QA5'),
		398 => array( 'title' => 'Kenya', 'code' => 'X3y'),
		399 => array( 'title' => 'Kiribati', 'code' => 'l2H'),
		400 => array( 'title' => 'Kosovs', 'code' => 'Pb3'),
		401 => array( 'title' => 'Kuwait', 'code' => 'P5F'),
		402 => array( 'title' => 'Kyrgyzstan', 'code' => 'uP6'),
		403 => array( 'title' => 'Laos', 'code' => 'Qy5'),
		404 => array( 'title' => 'Latvia', 'code' => 'j1D'),
		405 => array( 'title' => 'Lebanon', 'code' => 'Rl2'),
		406 => array( 'title' => 'Lesotho', 'code' => 'lB1'),
		407 => array( 'title' => 'Liberia', 'code' => '9Qw'),
		408 => array( 'title' => 'Libya', 'code' => 'v6I'),
		409 => array( 'title' => 'Liechtenstein', 'code' => '2GH'),
		410 => array( 'title' => 'Lithuania', 'code' => 'uI6'),
		411 => array( 'title' => 'Luxembourg', 'code' => 'EV8'),
		412 => array( 'title' => 'Macedonia', 'code' => '6GV'),
		413 => array( 'title' => 'Madagascar', 'code' => '4tE'),
		414 => array( 'title' => 'Malawi', 'code' => 'O9C'),
		415 => array( 'title' => 'Malaysia', 'code' => 'C9k'),
		416 => array( 'title' => 'Maldives', 'code' => '1Q3'),
		417 => array( 'title' => 'Mali', 'code' => 'Yi5'),
		418 => array( 'title' => 'Malta', 'code' => 'N11'),
		419 => array( 'title' => 'Marshall Islands', 'code' => 'Z3x'),
		420 => array( 'title' => 'Mauritania', 'code' => 'F18'),
		421 => array( 'title' => 'Mauritius', 'code' => 'mH4'),
		422 => array( 'title' => 'Mexico', 'code' => '8Qb'),
		423 => array( 'title' => 'Micronesia', 'code' => 'H6t'),
		424 => array( 'title' => 'Moldova', 'code' => 'FD8'),
		425 => array( 'title' => 'Monaco', 'code' => 't0X'),
		426 => array( 'title' => 'Mongolia', 'code' => 'X8h'),
		427 => array( 'title' => 'Montenegro', 'code' => '61A'),
		428 => array( 'title' => 'Morocco', 'code' => 'M2e'),
		429 => array( 'title' => 'Mozambique', 'code' => 'J7N'),
		430 => array( 'title' => 'Myanmar ', 'code' => 'YB9'),
		431 => array( 'title' => 'Namibia', 'code' => 'r0H'),
		432 => array( 'title' => 'Nauru', 'code' => 'M09'),
		433 => array( 'title' => 'Nepal', 'code' => 'E0c'),
		434 => array( 'title' => 'Netherlands', 'code' => '8jV'),
		435 => array( 'title' => 'New Zealand', 'code' => '0Mi'),
		436 => array( 'title' => 'Nicaragua', 'code' => '5dN'),
		437 => array( 'title' => 'Niger', 'code' => 'Rj0'),
		438 => array( 'title' => 'Nigeria', 'code' => '8oM'),
		439 => array( 'title' => 'North Korea', 'code' => '3Yz'),
		440 => array( 'title' => 'Norvay', 'code' => '4KE'),
		441 => array( 'title' => 'Oman', 'code' => '8NL'),
		442 => array( 'title' => 'Pakistan', 'code' => 'n4T'),
		443 => array( 'title' => 'Palau', 'code' => '8G2'),
		444 => array( 'title' => 'Panama', 'code' => '93O'),
		445 => array( 'title' => 'Papua New Guinea', 'code' => 'FD4'),
		446 => array( 'title' => 'Paraguay', 'code' => 'y5O'),
		447 => array( 'title' => 'Peru', 'code' => '4MJ'),
		448 => array( 'title' => 'Philippines', 'code' => '2qL'),
		449 => array( 'title' => 'Poland ', 'code' => 'j0R'),
		450 => array( 'title' => 'Portugal', 'code' => '0Rq'),
		451 => array( 'title' => 'Qatar', 'code' => 'a8S'),
		452 => array( 'title' => 'Romania', 'code' => 'nC7'),
		453 => array( 'title' => 'Russia', 'code' => 'D1H'),
		454 => array( 'title' => 'Rwanda', 'code' => '8UD'),
		455 => array( 'title' => 'Saint Kitts and Nevis', 'code' => 'X2d'),
		456 => array( 'title' => 'Saint Lucia', 'code' => 'I5e'),
		457 => array( 'title' => 'Saint Vincent and the Grenadines', 'code' => '3Kf'),
		458 => array( 'title' => 'Samoa', 'code' => '54E'),
		459 => array( 'title' => 'San Marino', 'code' => 'K4F'),
		460 => array( 'title' => 'Sao Tome and Principe', 'code' => 'cZ9'),
		461 => array( 'title' => 'Saudi Arabia', 'code' => 'J06'),
		462 => array( 'title' => 'Senegal', 'code' => 'x2O'),
		463 => array( 'title' => 'Serbia', 'code' => 'GC6'),
		464 => array( 'title' => 'Seychelles', 'code' => 'JE6'),
		465 => array( 'title' => 'Sierra Leone', 'code' => 'mS4'),
		466 => array( 'title' => 'Singapore', 'code' => 'O6e'),
		467 => array( 'title' => 'Slovakia', 'code' => 'Y2i'),
		468 => array( 'title' => 'Slovenia', 'code' => 'ZR1'),
		469 => array( 'title' => 'Solomon Islands', 'code' => '0U1'),
		470 => array( 'title' => 'Somalia', 'code' => '3fH'),
		471 => array( 'title' => 'South Africa', 'code' => '7xS'),
		472 => array( 'title' => 'South Korea', 'code' => '0W3'),
		473 => array( 'title' => 'South Sudan', 'code' => 'H4u'),
		474 => array( 'title' => 'Spain', 'code' => 'A5d'),
		475 => array( 'title' => 'Sri Lanka', 'code' => '9JL'),
		476 => array( 'title' => 'Sudan', 'code' => 'Wh1'),
		477 => array( 'title' => 'Suriname', 'code' => '7Rb'),
		478 => array( 'title' => 'Swaziland', 'code' => 'f6L'),
		479 => array( 'title' => 'Sweden', 'code' => 'oZ3'),
		480 => array( 'title' => 'Switzerland', 'code' => '8aW'),
		481 => array( 'title' => 'Syria', 'code' => 'UZ9'),
		482 => array( 'title' => 'Taiwan', 'code' => 'Rg9'),
		483 => array( 'title' => 'Tajikistan', 'code' => '7Qa'),
		484 => array( 'title' => 'Tanzania', 'code' => 'VU7'),
		485 => array( 'title' => 'Thailand', 'code' => 'V6r'),
		486 => array( 'title' => 'Timor-Leste', 'code' => '52C'),
		487 => array( 'title' => 'Togo', 'code' => 'HH3'),
		488 => array( 'title' => 'Tonga', 'code' => '8Ox'),
		489 => array( 'title' => 'Trinidad and Tobago', 'code' => 'oZ8'),
		490 => array( 'title' => 'Tunisia', 'code' => 'pD6'),
		491 => array( 'title' => 'Turkey', 'code' => 'YZ9'),
		492 => array( 'title' => 'Turkmenistan', 'code' => 'Tm5'),
		493 => array( 'title' => 'Tuvalu', 'code' => 'u0Y'),
		494 => array( 'title' => 'Uganda', 'code' => 'eJ2'),
		495 => array( 'title' => 'Ukraine', 'code' => '2Mg'),
		496 => array( 'title' => 'United Arab Emirates', 'code' => 'DT3'),
		497 => array( 'title' => 'United Kingdom', 'code' => 'Dw0'),
		498 => array( 'title' => 'United States of America', 'code' => 'R04'),
		499 => array( 'title' => 'Uruguay', 'code' => 'aL9'),
		500 => array( 'title' => 'Uzbekistan', 'code' => 'zJ3'),
		501 => array( 'title' => 'Vanuatu', 'code' => 'D0Y'),
		502 => array( 'title' => 'Vatican City', 'code' => 'FG2'),
		503 => array( 'title' => 'Venezuela', 'code' => 'Eg6'),
		504 => array( 'title' => 'Vietnam', 'code' => 'l2A'),
		505 => array( 'title' => 'Yemen', 'code' => 'YZ0'),
		506 => array( 'title' => 'Zambia', 'code' => '9Be'),
		507 => array( 'title' => 'Zimbabwe', 'code' => '80Y'),
	);

	function onAfterInitialise()
	{
		$this->referrer = '//' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];

		$this->api_key = $this->params->get('api_key', '');
		$this->source_language = $this->params->get( 'source_language', '' );
		$this->target_languages = $this->params->get( 'target_languages', array() );
		$this->style_change_language = $this->params->get( 'style_change_language', array() );
		$this->style_change_flag = $this->params->get( 'style_change_flag', array() );
		$this->style_flag = $this->params->get( 'style_flag', 'rect' );
		$this->style_text = $this->params->get( 'style_text', 'full-text' );
		$this->style_position = $this->params->get( 'style_position', 'right-bottom' );
		$this->style_indenting = $this->params->get( 'style_indenting', '0' );
		$this->alternate = $this->params->get( 'alternate', '1' );

		//

		if( !empty( $this->target_languages ) )
		{
			$prefix = $this->getPrefix();

			preg_match( '/^(' . preg_quote( $prefix, '/' ) . '('. implode( '|', $this->target_languages ) .')\/).*/', $_SERVER["REQUEST_URI"], $matches );

			if( !empty( $matches ) )
			{
				$this->language_code = $matches[2];

				$tmp = $matches[1];

				$_SERVER['REQUEST_URI'] = $this->customReplace( '/^' . preg_quote( $tmp, '/' ) . '(.*)/', $prefix . '\1', $_SERVER['REQUEST_URI'] );
			}
		}
	}

	function onAfterRender()
	{
		$app = JFactory::getApplication();

		if( $app->isAdmin() ) return;

		$content = $app->getBody();

		if( !empty( $this->language_code ) )
		{
			$content = $this->translateContent( $content );
		}
		$code = $this->getButton();

		$content = $this->customReplace( '/<\/body(\s+)?>(\s+)?<\/html(\s+)?>(\s+)?$/', $code . '</body\1>\2</html\3>\4', $content );
		$app->setBody( $content );
	}

	function getLanguages()
	{
		return $this->languages;
	}

	function getFlags()
	{
		return $this->flags;
	}

	function replaceLinks( $output, $rows )
	{
		$site_url = JURI::base();
		$site_host = parse_url( $site_url, PHP_URL_HOST );
		$site_path = parse_url( $site_url, PHP_URL_PATH );
		$prefix = $this->getPrefix();

		$patterns = array();
		$replacements = array();

		$rows = array_unique( $rows );

		usort( $rows, function( $a, $b ) {
			if( strlen( $a ) > strlen( $b ) ) return -1;
			if( strlen( $a ) < strlen( $b ) ) return 1;
			if( strlen( $a ) == strlen( $b ) ) return 0;
		});

		foreach( $rows as $row )
		{
			$link = parse_url( $row );

			if( ( empty( $link['host'] ) && !empty( $link['path'] ) ) || ( !empty( $link['host'] ) && $link['host'] == $site_host ) )
			{
				if( strncmp( $site_path, $link['path'], strlen( $site_path ) ) === 0 )
				{
					if( stripos( $link['path'], 'wp-admin' ) === false )
					{
						$link['path'] = $this->customReplace( '/^' . preg_quote( $prefix, '/' ) . '(.*)/', $prefix . '' . $this->language_code . '/' . '\1', $link['path'] );
						$new = $this->unparse_url( $link );

						$patterns[] = '/(<([\s\n\t]+)?a([^>]+)href([\s\n\t]+)?=([\s\n\t]+)?["|\'])(' . preg_quote( $row, '/' ) . ')(["|\'])/';
						$replacements[] = '\1' . $new . '\7';
					}
				}
			}
		}

		if( !empty( $patterns ) && !empty( $replacements ) )
		{
			$output = $this->customReplace( $patterns, $replacements, $output );
		}
		return $output;
	}

	function replaceSegments( $output, $items )
	{
		usort( $items, function( $a, $b ) {
			if( $a->source_length > $b->source_length ) return -1;
			if( $a->source_length < $b->source_length ) return 1;
			if( $a->source_length == $b->source_length ) return 0;
		});

		$patterns = array();
		$replacements = array();

		foreach( $items as $item )
		{
			if( !empty( $item->source_text ) && !empty( $item->translate_text ) )
			{
				$patterns[] = '/(["|\'|>]([\s\n\t]+)?)' . preg_quote( $item->source_text, '/' ) . '(([\s\n\t]+)?["|\'|<])/';

				if( !empty( $item->translate_custom ) )
				{
					$replacements[] = '\1' . $item->translate_custom . '\3';
				}
					
				else
				{
					$replacements[] = '\1' . $item->translate_text . '\3';
				}
			}
		}

		if( !empty( $patterns ) && !empty( $replacements ) )
		{
			$output = $this->customReplace( $patterns, $replacements, $output );
		}
		return $output;
	}

	function unparse_url( $parsed_url )
	{
		$scheme   = isset($parsed_url['scheme']) ? $parsed_url['scheme'] . '://' : '';
		$host     = isset($parsed_url['host']) ? $parsed_url['host'] : '';
		$port     = isset($parsed_url['port']) ? ':' . $parsed_url['port'] : '';
		$user     = isset($parsed_url['user']) ? $parsed_url['user'] : '';
		$pass     = isset($parsed_url['pass']) ? ':' . $parsed_url['pass']  : '';
		$pass     = ($user || $pass) ? "$pass@" : '';
		$path     = isset($parsed_url['path']) ? $parsed_url['path'] : '';
		$query    = isset($parsed_url['query']) ? '?' . $parsed_url['query'] : '';
		$fragment = isset($parsed_url['fragment']) ? '#' . $parsed_url['fragment'] : '';

		return "$scheme$user$pass$host$port$path$query$fragment"; 
	}

	public function parse( $output )
	{
		$doc = new DOMDocument();
		$doc->loadHTML( $output );

		$this->temp( $doc );

		//

		$titlelist = $doc->getElementsByTagName('title');

		if( $titlelist->length > 0 )
		{
			$value = trim( $titlelist->item(0)->textContent );

			if( !empty( $value ) )
			{
				$this->segments['meta'][$value] = $value;
			}
		}

		sort( $this->segments['text'] );
		sort( $this->segments['attributes'] );
		sort( $this->segments['meta'] );
		sort( $this->segments['links'] );
	}	

	function temp( $doc )
	{
		foreach( $doc->childNodes as $child )
		{
			if( $child->nodeType === 3 )
			{
				$value = trim( $child->textContent );

				if( !empty( $value ) )
				{
					$this->segments['text'][$value] = $value;
				}
			}

			else
			{
				if( $child->nodeType === 1 )
				{
					if( $child->hasAttribute('title') )
					{
						$attrValue = trim( $child->getAttribute('title') );
					}

					if( $child->hasAttribute('alt') )
					{
						$attrValue = trim( $child->getAttribute('alt') );
					}

					if( $child->hasAttribute('placeholder') )
					{
						$attrValue = trim( $child->getAttribute('placeholder') );
					}

					if( !empty( $attrValue ) )
					{
						$this->segments['attributes'][$attrValue] = $attrValue;							
					}

					if( strcasecmp( $child->nodeName, 'a' ) === 0 )
					{
						if( $child->hasAttribute('href') )
						{
							$metaAttrValue = trim( $child->getAttribute('href') );

							if( !empty( $metaAttrValue ) )
							{
								$this->segments['links'][$metaAttrValue] = $metaAttrValue;							
							}
						}
					}

					if( strcasecmp( $child->nodeName, 'meta' ) === 0 )
					{
						if( $child->hasAttribute('name') )
						{
							$metaAttributeName = trim( $child->getAttribute('name') );

							if( strcasecmp( $metaAttributeName, 'description' ) === 0 || strcasecmp( $metaAttributeName, 'keywords' ) === 0 )
							{
								if( $child->hasAttribute('content') )
								{
									$metaAttrValue = trim( $child->getAttribute('content') );

									if( !empty( $metaAttrValue ) )
									{
										$this->segments['meta'][$metaAttrValue] = $metaAttrValue;							
									}
								}
							}							
						}
					}

					if( strcasecmp( $child->nodeName, 'script' ) !== 0 && strcasecmp( $child->nodeName, 'style' ) !== 0 && strcasecmp( $child->nodeName, 'title' ) !== 0 )
					{
						$this->temp( $child );
					}
				}
			}
		}
	}

	public function translateContent( $output )
	{
		$SYMBOL_HORIZONTAL_TAB	= chr( 9 );
		$SYMBOL_LINE_FEED		= chr( 10 );
		$SYMBOL_CARRIAGE_RETURN	= chr( 13 );
		$SYMBOL_SPACE			= chr( 32 );
		$SYMBOL_DOUBLE_QUOTES	= chr( 34 );
		$SYMBOL_SINGLE_QUOTE	= chr( 39 );
		$SYMBOL_SLASH			= chr( 47 );
		$SYMBOL_LEFT_QUOTE		= chr( 60 );
		$SYMBOL_EQUALS			= chr( 61 );
		$SYMBOL_RIGHT_QUOTE		= chr( 62 );

		// Search segments

		if( extension_loaded('xml') )
		{
			$this->parse( $output );

			$segments = $this->segments['text'];
			$attributes = $this->segments['attributes'];
			$meta = $this->segments['meta'];
			$links = $this->segments['links'];
		}

		else
		{
			require_once('parser.php');

			$parser = new Parser( $output );

			$segments = $parser->getSegments();
			$attributes = $parser->getAttributes();
			$meta = $parser->getMeta();
			$links = $parser->getLinks();
		}

		//
		
		$response = $this->stripApi( '/user/translation/init/', array(
			'dataType' => 'serialize',
			'api_key' => $this->api_key,
			'referrer' => $this->referrer,
			'source_language' => $this->source_language,
			'target_language' => $this->language_code,
			'segments' => $segments,
			'attributes' => $attributes,
			'meta' => $meta,
		));

		if( !empty( $response->items ) )
		{
			$output = $this->replaceSegments( $output, $response->items );
		}

		if( !empty( $links ) )
		{
			$output = $this->replaceLinks( $output, $links );
		}
		return $output;
	}

	public function getLocation( $prefix, $language_code )
	{
		if( $this->source_language == $language_code )
		{
			return $_SERVER["REQUEST_URI"];
		}

		else
		{
			return $this->customReplace( '/^' . preg_quote( $prefix, '/' ) . '(.*)/', $prefix . '' . $language_code . '/' . '\1', $_SERVER["REQUEST_URI"] );
		}
	}

	public function getButton()
	{
		$languages = array();

		$prefix = $this->getPrefix();

		if( !empty( $this->language_code ) )
		{
			$current_language_code = $this->language_code;
		}

		else
		{
			$current_language_code = $this->source_language;
		}

		foreach( $this->languages as $id => $language )
		{
			if( $current_language_code == $language['code2'] )
			{
				$location = $this->getLocation( $prefix, $language['code2'] );

				$languages[] = '{"id":"'. $id .'", "location":"'. $location .'", "active":true}';
			}
		}

		if( !empty( $this->language_code ) )
		{
			foreach( $this->languages as $id => $language )
			{
				if( $this->source_language == $language['code2'] )
				{
					$location = $this->getLocation( $prefix, $language['code2'] );

					$languages[] = '{"id":"'. $id .'", "location":"'. $location .'", "active":false}';
				}
			}
		}

		foreach( $this->target_languages as $language_code )
		{
			foreach( $this->languages as $id => $language )
			{
				if( $language_code == $language['code2'] && $current_language_code != $language['code2'] )
				{
					$location = $this->getLocation( $prefix, $language['code2'] );

					$languages[] = '{"id":"'. $id .'", "location":"'. $location .'", "active":false}';
				}
			}
		}

		//

		$i = 0;

		$temp = array();

		while( $i < 5 )
		{
			if( !empty( $this->style_change_language[$i] ) )
			{
				$temp[] = '"' . $this->style_change_language[$i] . '":"' . $this->style_change_flag[$i] . '"';
			}
			$i++;
		}

		$change = '{' . implode( ',', $temp ) .'}';

		//

		if( $this->style_position == 'right-top' )
		{
			$positionTop = $this->style_indenting;
			$positionBottom = "null";
		}

		else
		{
			$positionTop = "null";
			$positionBottom = $this->style_indenting;
		}

		$code = '';

		$code .= '<script src="//cdn.conveythis.com/js/17/conveythis-17.js"></script>';
		$code .= "\n";
		$code .= '<script type="text/javascript">';
		$code .= 'window.onload=function(){';
		$code .= 'conveythis.init({';
		$code .= 'change:' . $change . ',';
		$code .= 'icon:"' . $this->style_flag . '",';
		$code .= 'text:"' . $this->style_text . '",';
		$code .= 'positionTop:' . $positionTop . ',';
		$code .= 'positionBottom:' . $positionBottom . ',';
		$code .= 'languages:[' . implode( ', ', $languages ) . '],';
		$code .= 'callback:function(data){location.href=data.location;}';
		$code .= '});';
		$code .= '};';
		$code .= '</script>';
		$code .= "\n";
		
		return $code;
	}


	function api( $URL, $params = array() )
	{
		ksort( $params );

		//
			
		$ch = curl_init();

		curl_setopt($ch, CURLOPT_URL, $URL );
		curl_setopt($ch, CURLOPT_VERBOSE, 1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query( $params ) );

		$response = curl_exec($ch);

		curl_close($ch);

		return unserialize( $response );
	}


	function stripApi( $URL, $params = array() )
	{
		$response = $this->api( $this->api_url . $URL, $params );

		if( !empty( $response ) )
		{
			if( $response->code == 200 )
			{
				return $response->data;
			}

			else
			{
				if( !empty( $response->message ) )
				{
					$message = JText::_( $response->message );

					if( strpos( $message, '#' ) )
					{
						$message = $this->customReplace( '/#/', '<a target="_blank" href="https://www.conveythis.com/dashboard/pricing/">change plan</a>', $message );
					}

					return (object) array(
						'error' => $message,
					);
				}
			}
		}
	}

	function customReplace( $patterns, $replacements, $data )
	{
		return preg_replace( $patterns, $replacements, $data );
	}

	function getPrefix()
	{
		if( strpos( php_sapi_name(), 'cgi' ) !== false && !ini_get('cgi.fix_pathinfo') && !empty( $_SERVER['REQUEST_URI'] ) )
		{
			$script_name = $_SERVER['PHP_SELF'];
		}

		else
		{
			$script_name = $_SERVER['SCRIPT_NAME'];
		}
		$script_name = $this->customReplace( array("/'/", '/"/', '/</', '/>/'), array('%27', '%22', '%3C', '%3E'), $script_name );

		return rtrim( dirname( $script_name ), '/\\' ).'/';
	}
}
